searchData={"items":[{"type":"module","title":"AhoCorasickNif","doc":"A NIF wrapper for the Rust crate aho-corasick-nif.\n\nThis module provides a NIF wrapper for the Rust crate aho-corasick-nif. The NIFs are implemented\nin Rust and exposed to Elixir via the Rustler library.","ref":"AhoCorasickNif.html"},{"type":"function","title":"AhoCorasickNif.add_patterns/2","doc":"","ref":"AhoCorasickNif.html#add_patterns/2"},{"type":"function","title":"AhoCorasickNif.add_patterns!/2","doc":"","ref":"AhoCorasickNif.html#add_patterns!/2"},{"type":"function","title":"AhoCorasickNif.find_all/2","doc":"","ref":"AhoCorasickNif.html#find_all/2"},{"type":"function","title":"AhoCorasickNif.find_all!/2","doc":"","ref":"AhoCorasickNif.html#find_all!/2"},{"type":"function","title":"AhoCorasickNif.find_all_overlapping/2","doc":"","ref":"AhoCorasickNif.html#find_all_overlapping/2"},{"type":"function","title":"AhoCorasickNif.find_all_overlapping!/2","doc":"","ref":"AhoCorasickNif.html#find_all_overlapping!/2"},{"type":"function","title":"AhoCorasickNif.find_first/2","doc":"","ref":"AhoCorasickNif.html#find_first/2"},{"type":"function","title":"AhoCorasickNif.is_match/2","doc":"","ref":"AhoCorasickNif.html#is_match/2"},{"type":"function","title":"AhoCorasickNif.is_match!/2","doc":"","ref":"AhoCorasickNif.html#is_match!/2"},{"type":"function","title":"AhoCorasickNif.new/2","doc":"","ref":"AhoCorasickNif.html#new/2"},{"type":"function","title":"AhoCorasickNif.new!/2","doc":"","ref":"AhoCorasickNif.html#new!/2"},{"type":"function","title":"AhoCorasickNif.remove_patterns/2","doc":"","ref":"AhoCorasickNif.html#remove_patterns/2"},{"type":"function","title":"AhoCorasickNif.remove_patterns!/2","doc":"","ref":"AhoCorasickNif.html#remove_patterns!/2"},{"type":"function","title":"AhoCorasickNif.replace_all/3","doc":"","ref":"AhoCorasickNif.html#replace_all/3"},{"type":"function","title":"AhoCorasickNif.replace_all!/3","doc":"","ref":"AhoCorasickNif.html#replace_all!/3"},{"type":"type","title":"AhoCorasickNif.t/0","doc":"","ref":"AhoCorasickNif.html#t:t/0"},{"type":"module","title":"AhoCorasickNif.Native.BuilderOptions","doc":"Struct to represent the options passed to the builder.\n\nThe options are:\n\n- `:aho_corasick_kind` - the kind of Aho-Corasick algorithm to use\n  - `nil` - use the default algorithm (it makes the chose based ont pattern counts)\n  - `:noncontiguous_nfa` - use the noncontiguous NFA algorithm\n  - `:contiguous_nfa` - use the contiguous NFA algorithm\n  - `:dfa` - use the DFA algorithm\n- `:ascii_case_insensitive` - whether to ignore case for ASCII characters\n- `:byte_classes` - whether to use byte classes\n- `:dense_depth` - the depth at which to switch to the dense representation\n  - `nil` - use the default depth (it uses defaults for each automata type)\n  - `non_neg_integer()` - use the given depth\n- `:match_kind` - the kind of match to return\n  - `:standard` - return all matches\n  - `:leftmost_longest` - return the leftmost longest match\n  - `:leftmost_first` - return the leftmost first match\n- `:prefilter` - whether to use the prefilter\n- `:start_kind` - the kind of start to use\n  - `:both` - match both anchored and unanchored patterns\n  - `:unanchored` - match only unanchored patterns\n  - `:anchored` - match only anchored patterns","ref":"AhoCorasickNif.Native.BuilderOptions.html"},{"type":"function","title":"AhoCorasickNif.Native.BuilderOptions.validate/1","doc":"Validate the options passed to the builder.","ref":"AhoCorasickNif.Native.BuilderOptions.html#validate/1"},{"type":"function","title":"AhoCorasickNif.Native.BuilderOptions.validate!/1","doc":"Validate the options passed to the builder and raise an error if invalid.","ref":"AhoCorasickNif.Native.BuilderOptions.html#validate!/1"},{"type":"type","title":"AhoCorasickNif.Native.BuilderOptions.aho_corasick_kind/0","doc":"","ref":"AhoCorasickNif.Native.BuilderOptions.html#t:aho_corasick_kind/0"},{"type":"type","title":"AhoCorasickNif.Native.BuilderOptions.match_kind/0","doc":"","ref":"AhoCorasickNif.Native.BuilderOptions.html#t:match_kind/0"},{"type":"type","title":"AhoCorasickNif.Native.BuilderOptions.start_kind/0","doc":"","ref":"AhoCorasickNif.Native.BuilderOptions.html#t:start_kind/0"},{"type":"type","title":"AhoCorasickNif.Native.BuilderOptions.t/0","doc":"","ref":"AhoCorasickNif.Native.BuilderOptions.html#t:t/0"},{"type":"module","title":"AhoCorasickNif.Native.Match","doc":"Struct to represent a match found by the Aho-Corasick algorithm.","ref":"AhoCorasickNif.Native.Match.html"},{"type":"type","title":"AhoCorasickNif.Native.Match.t/0","doc":"A match found by the Aho-Corasick algorithm.\n\n- `:pattern` - the pattern that was matched\n- `:match_` - the substring of the haystack that was matched\n- `:start` - the start index of the match in the haystack (inclusive)\n- `:end` - the end index of the match in the haystack (exclusive)","ref":"AhoCorasickNif.Native.Match.html#t:t/0"},{"type":"module","title":"AhoCorasickNif.NifBridge","doc":"","ref":"AhoCorasickNif.NifBridge.html"},{"type":"function","title":"AhoCorasickNif.NifBridge.add_patterns/2","doc":"","ref":"AhoCorasickNif.NifBridge.html#add_patterns/2"},{"type":"function","title":"AhoCorasickNif.NifBridge.find_all/2","doc":"","ref":"AhoCorasickNif.NifBridge.html#find_all/2"},{"type":"function","title":"AhoCorasickNif.NifBridge.find_all_overlapping/2","doc":"","ref":"AhoCorasickNif.NifBridge.html#find_all_overlapping/2"},{"type":"function","title":"AhoCorasickNif.NifBridge.find_first/2","doc":"","ref":"AhoCorasickNif.NifBridge.html#find_first/2"},{"type":"function","title":"AhoCorasickNif.NifBridge.is_match/2","doc":"","ref":"AhoCorasickNif.NifBridge.html#is_match/2"},{"type":"function","title":"AhoCorasickNif.NifBridge.new/2","doc":"","ref":"AhoCorasickNif.NifBridge.html#new/2"},{"type":"function","title":"AhoCorasickNif.NifBridge.remove_patterns/2","doc":"","ref":"AhoCorasickNif.NifBridge.html#remove_patterns/2"},{"type":"function","title":"AhoCorasickNif.NifBridge.replace_all/3","doc":"","ref":"AhoCorasickNif.NifBridge.html#replace_all/3"},{"type":"module","title":"AhoCorasickNif.Types","doc":"Types used in the AhoCorasickNif module.","ref":"AhoCorasickNif.Types.html"},{"type":"type","title":"AhoCorasickNif.Types.automata/0","doc":"A reference to an AhoCorasickNif automata.\n\nThis is a reference to a uniquly identifable AhoCorasickNif automata in the NIF memory space.","ref":"AhoCorasickNif.Types.html#t:automata/0"},{"type":"type","title":"AhoCorasickNif.Types.errors/0","doc":"Ther are several common errors and failure modes that can occur when using the NIFs.\n\n`:unsupported_type` - The type of the argument passed to the NIF is not supported. Try to validate\nthe passed args. (The library should manage this for you, so this is a bug in the library.)\n`:lock_fail` - The NIF was unable to acquire a lock on the automata. This indicates that the\nautomata is being used by another process. You can try again... but you should try to figure out\nhow you shared the reference to the automata in the first place.\n\n`String.t()` - The NIF returned a string. This is likely a bug in the library related to the way\n  patterns are being passed to the NIF.","ref":"AhoCorasickNif.Types.html#t:errors/0"},{"type":"extras","title":"AhoCorasickNif","doc":"# AhoCorasickNif\n\nAn Elixir wrapper over the Rust `aho-corasick` library.","ref":"readme.html"},{"type":"extras","title":"Installation - AhoCorasickNif","doc":"```elixir\ndef deps do\n  [\n    {:aho_corasick_nif, \"~> 0.1.0-beta.1\"}\n  ]\nend\n```","ref":"readme.html#installation"}],"content_type":"text/markdown"}